{
  Objeto...: biblioteca para operaes binrias.
  Categoria: Open-Source
  Autor....: Daniel Pereira Guimares
  E-mail...: tecnobyte@ulbrajp.com.br
  Home-Page: www.ulbrajp.com.br/~tecnobyte
  Reviso..: 21 de Fevereiro de 2001
}

unit tbBin;

interface

uses Windows, SysUtils;

{ Converte Inteiro para string com a representao binria }
function tbIntToBin(X: integer): string;
{ Converte uma string com a representao binria para inteiro }
function tbBinToInt(const S: string): integer;

{ Rola bits para a esquerda }
function tbBitROL8(const X, C: byte): byte;
function tbBitROL16(const X: Word; const C: byte): Word;
function tbBitROL32(const X: integer; const C: byte): integer;

{ Rola bits para a direita }
function tbBitROR8(const X, C: byte): byte;
function tbBitROR16(const X: Word; const C: byte): Word;
function tbBitROR32(const X: integer; const C: byte): integer;

{ Retorna true se o bit da posio indicada estiver ligado }
function tbGetBit(const X: integer; const Bit: byte): boolean;
{ Liga o bit da posio indicada }
function tbSetBit(const X: integer; const Bit: byte): integer;

implementation

function tbIntToBin(X: integer): string;
var
  I: byte;
begin
  Result := '';
  for I := 1 to SizeOf(X) * 8 do
    if tbGetBit(X, I-1) then
      Result := '1' + Result
    else
      Result := '0' + Result;
end;

function tbBinToInt(const S: string): integer;
var
  I, Len: byte;
begin
  { Ainda tem erro com negativos }
  Result := 0;
  Len := Length(S);
  for I := 1 to Len do
    if S[I] = '1' then
      Result := integer(tbSetBit(Result, Len - I));
end;

function tbBitROL8(const X, C: byte): byte;
asm
  mov cl, &C
  mov al, &X
  rol al, cl
  mov &Result, al
end;

function tbBitROL16(const X: Word; const C: byte): Word;
asm
  mov cl, &C
  mov ax, &X
  rol ax, cl
  mov &Result, ax
end;

function tbBitROL32(const X: integer; const C: byte): integer;
asm
  mov cl, &C
  mov eax, &X
  rol eax, cl
  mov &Result, eax
end;

function tbBitROR8(const X, C: byte): byte;
asm
  mov cl, &c
  mov al, &X
  ror al, cl
  mov &Result, al
end;

function tbBitROR16(const X: Word; const C: byte): Word;
asm
  mov cl, &C
  mov ax, &X
  ror ax, cl
  mov &Result, ax
end;

function tbBitROR32(const X: integer; const C: byte): integer;
asm
  mov cl, &C
  mov eax, &X
  ror eax, cl
  mov &Result, eax
end;

function tbGetBit(const X: integer; const Bit: byte): boolean;
begin
  Result := (X and  (1 shl Bit)) > 0;
end;

function tbSetBit(const X: integer; const Bit: byte): integer;
begin
  Result := X or (1 shl Bit);
end;

end.
